
From: Ingo Molnar <mingo@elte.hu>

It's not necessary to keep IRQs disabled after the BKL has been dropped. 
In fact i think IRQ-disabling doesnt have to be done at all, the patch
below ought to solve this scenario equally well, and should solve the PPC
side-effects too.

Signed-off-by: Ingo Molnar <mingo@elte.hu>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/init/main.c |    9 ++-------
 1 files changed, 2 insertions(+), 7 deletions(-)

diff -puN init/main.c~rest_init-local-irq-fix init/main.c
--- 25/init/main.c~rest_init-local-irq-fix	2005-01-25 21:25:05.647364864 -0800
+++ 25-akpm/init/main.c	2005-01-25 21:25:05.650364408 -0800
@@ -374,14 +374,9 @@ static void noinline rest_init(void)
 {
 	kernel_thread(init, NULL, CLONE_FS | CLONE_SIGHAND);
 	numa_default_policy();
-	/*
-	 * Re-enable preemption but disable interrupts to make sure
-	 * we dont get preempted until we schedule() in cpu_idle().
-	 */
-	local_irq_disable();
-	preempt_enable_no_resched();
 	unlock_kernel();
- 	cpu_idle();
+	preempt_enable_no_resched();
+	cpu_idle();
 } 
 
 /* Check for early params. */
_
